;----------------------------------------------------------------------------
;				DLL.asm
;----------------------------------------------------------------------------
   .386
   .model flat,stdcall

   option casemap:none
   include \tools\masm32\include\windows.inc
   include \tools\masm32\include\user32.inc
   include \tools\masm32\include\kernel32.inc

   includelib \tools\masm32\lib\user32.lib
   includelib \tools\masm32\lib\kernel32.lib
MessageBoxW PROTO :DWORD,:DWORD,:DWORD,:DWORD
CLIENTID struct
	UniqueProcess DWORD 0
	UniqueThread DWORD 0
CLIENTID ends
THREAD_BASIC_INFORMATION struct
	ExitSTatus DWORD 0
	TebBaseAddress DWORD 0
	ClientId CLIENTID <0>
	AffinityMask DWORD 0
	Priority DWORD 0
	BasePriority DWORD 0
THREAD_BASIC_INFORMATION ends
startproc macro
	push esi
	push edi
	push ebx
	push ebp
endm

endproc macro
	pop ebp
	pop ebx
	pop edi
	pop esi
endm

;===============================================================================;
;			Initialized Data Section				
;===============================================================================;
.data										
;===============================================================================;
	ParameterForLoadLibrary dd 0;    DLL   	
	ThreadId dd 0; 	
	lib db "c:\\dll.dll",0; DLL,     	
	dwSize equ $-lib;    DLL
	OpenThreadStr db "OpenThread",0
	loadlibraryName db "LoadLibraryA",0;  LoadLibraryA
	kern db "KERNEL32.dll",0
	CreateThreadStr db "ZwCreateThread",0
	ResumeThreadStr db "ZwResumeThread",0
	QueryInfoStr db "ZwQueryInformationThread",0
	nt db "NTDLL.dll",0
	user db "user32.dll",0
	HookFuncStr db "MessageBoxW",0
	Message db "  ExitProcess",0
	TitleMessage db "- ",0
	TextMessage db "      ? ;)",0
	NewProcess dd 0
code1 label byte
	db 68h
	Hooker1 dd 0
	db 0c3h
size_code1 equ $-code1

code2 label byte
	db 68h
	Hooker2 dd 0
	db 0c3h
size_code2 equ $-code1

code3 label byte
	db 68h
	Hooker3 dd 0
	db 0c3h
size_code3 equ $-code1

;===============================================================================;
;			Uninitialized Data Section				
;===============================================================================;
.data?										
;===============================================================================;
	_LoadLibrary dd ?;  LoadLibrary
	RealAddr1 DWORD ?
	AddrCreateThread DWORD ?
	AddrResumeThread DWORD ?
	hSnap dd ?
	Thread THREADENTRY32 <?>
	CurrProcess dd ?
	CurrThread dd ?
	ThreadHandle dd ?
	_OpenThread dd ?
	ThreadID dd ?
	AddrFunc dd ?
	Old_Code1 db size_code1 dup (?)
	Old_Code2 db size_code2 dup (?)
	Old_Code3 db size_code2 dup (?)
.code
DllMain proc hInstDLL:HINSTANCE, reason:DWORD, reserved1:DWORD
	push esi
	push edi
	push ebp
	push ebx
	.if reason==DLL_PROCESS_ATTACH
		call SuspendThreads
		push offset user
		push offset HookFuncStr
		call SetHook1; MessageBoxA
		push offset nt
		push offset CreateThreadStr
		call SetHookZwCreateThread
		push offset nt
		push offset ResumeThreadStr
		call SetHookZwResumeThread
		call ResumeThreads
	.elseif reason==DLL_PROCESS_DETACH
		;
	.elseif reason==DLL_THREAD_ATTACH
		;
	.else    ; DLL_THREAD_DETACH
		;
	.endif
	pop ebx
	pop ebp
	pop edi
	pop esi
	mov  eax,TRUE
ret
DllMain Endp

Test1 proc
ret
Test1 endp

SuspendThreads proc

	invoke GetModuleHandle,offset kern
	invoke GetProcAddress,eax,offset OpenThreadStr
	mov _OpenThread,eax
	invoke GetCurrentThreadId
	mov CurrThread,eax
	invoke GetCurrentProcessId
	mov CurrProcess,eax

	invoke CreateToolhelp32Snapshot,TH32CS_SNAPTHREAD,0
	.if eax==-1
		xor eax,eax
		ret
	.endif
	mov hSnap,eax
	mov Thread.dwSize,sizeof THREADENTRY32
	invoke Thread32First,hSnap,offset Thread
	.if eax==0
		xor eax,eax
		ret
	.endif
NextThread:
	mov eax,CurrThread
	mov edx,CurrProcess
	.if (Thread.th32ThreadID!=eax)&&(Thread.th32OwnerProcessID==edx)
		push Thread.th32ThreadID
		push NULL
		push THREAD_SUSPEND_RESUME
		call _OpenThread
		mov ThreadHandle,eax
		.if ThreadHandle>0
			invoke SuspendThread,ThreadHandle
			invoke CloseHandle,ThreadHandle
		.endif
	.endif
	invoke Thread32Next,hSnap,offset Thread
	.if eax!=0
		jmp NextThread
	.endif 
	invoke CloseHandle,hSnap
	ret
SuspendThreads endp

ResumeThreads proc
	invoke GetModuleHandle,offset kern
	invoke GetProcAddress,eax,offset OpenThreadStr
	mov _OpenThread,eax
	invoke GetCurrentThreadId
	mov CurrThread,eax
	invoke GetCurrentProcessId
	mov CurrProcess,eax

	invoke CreateToolhelp32Snapshot,TH32CS_SNAPTHREAD,0
	.if eax==-1
		xor eax,eax
		ret
	.endif
	mov hSnap,eax
	mov Thread.dwSize,sizeof THREADENTRY32
	invoke Thread32First,hSnap,offset Thread
	.if eax==0
		xor eax,eax
		ret
	.endif
NextThread:
	mov eax,CurrThread
	mov edx,CurrProcess
	.if (Thread.th32ThreadID!=eax)&&(Thread.th32OwnerProcessID==edx)
		push Thread.th32ThreadID
		push NULL
		push THREAD_SUSPEND_RESUME
		call _OpenThread
		mov ThreadHandle,eax
		.if ThreadHandle>0
			invoke ResumeThread,ThreadHandle
			invoke CloseHandle,ThreadHandle
		.endif
	.endif
	invoke Thread32Next,hSnap,offset Thread
	.if eax!=0
		jmp NextThread
	.endif
	invoke CloseHandle,hSnap
	ret
ResumeThreads endp

SetHook1 proc NameFunc:dword,NameModul:dword 
	invoke GetModuleHandle,NameModul
	invoke GetProcAddress,eax,NameFunc
	mov RealAddr1,eax;   
	invoke ReadProcessMemory,-1,RealAddr1,offset Old_Code1,size_code1,0
	mov Hooker1,offset Hooker
	invoke WriteProcessMemory,-1,RealAddr1,offset code1,size_code1,0
	ret
SetHook1 endp

SetHookZwCreateThread proc NameFunc:dword,NameModul:dword 
	invoke GetModuleHandle,NameModul
	invoke GetProcAddress,eax,NameFunc
	mov AddrCreateThread,eax;   
	invoke ReadProcessMemory,-1,AddrCreateThread,offset Old_Code2,size_code2,0
	mov Hooker2,offset NewZwCreateThread
	invoke WriteProcessMemory,-1,AddrCreateThread,offset code2,size_code2,0
	ret
SetHookZwCreateThread endp

SetHookZwResumeThread proc NameFunc:dword,NameModul:dword 
	invoke GetModuleHandle,NameModul
	invoke GetProcAddress,eax,NameFunc
	mov AddrResumeThread,eax;   
	invoke ReadProcessMemory,-1,AddrResumeThread,offset Old_Code3,size_code3,0
	mov Hooker3,offset NewZwResumeThread
	invoke WriteProcessMemory,-1,AddrResumeThread,offset code3,size_code3,0
	ret 
SetHookZwResumeThread endp

TrueMessageBoxA proc x:dword,x1:dword,x2:dword,x3:dword
	call SuspendThreads
	invoke WriteProcessMemory,-1,RealAddr1,offset Old_Code1,size_code1,0
	push x3
	push x2
	push x1
	push x
	call MessageBoxA
	push eax
	invoke WriteProcessMemory,-1,RealAddr1,offset code1,size_code1,0
	call ResumeThreads
	pop eax
	ret
TrueMessageBoxA endp 

Hooker proc x:dword,x1:dword,x2:dword,x3:dword
	push x3
	push offset TitleMessage
	push offset TextMessage
	push x
	call TrueMessageBoxA
	ret
Hooker endp

NewZwCreateThread proc ThreadHandle1:DWORD, DesiredAccess: DWORD, ObjectAttributes:DWORD, ProcessHandle:DWORD, ClientId: DWORD, ThreadContext: DWORD, UserStack:DWORD, CreateSuspended: DWORD
	startproc
	invoke GetCurrentProcess
	invoke WriteProcessMemory,eax,AddrCreateThread,offset Old_Code2,size_code2,0; 
	push TRUE
	push UserStack
	push ThreadContext
	push ClientId
	push ProcessHandle
	push ObjectAttributes
	push DesiredAccess
	push ThreadHandle1
	call AddrCreateThread
	push eax
	mov eax,CurrProcess
	mov edi,ClientId
	assume edi:PTR CLIENTID
	.if eax!=[edi].UniqueProcess
		mov NewProcess,1
	.endif
	
	.if CreateSuspended==0
		invoke ResumeThread,ThreadHandle1
	.endif
	invoke GetCurrentProcess
	invoke WriteProcessMemory,eax,AddrCreateThread,offset code2,size_code2,0; 
	pop eax
	endproc
	ret
NewZwCreateThread endp

NewZwResumeThread proc ThreadHandle1:DWORD, PriviousSuspendCount: DWORD
LOCAL ThreadInfo:THREAD_BASIC_INFORMATION
LOCAL hProcess: DWORD
	startproc
	invoke GetCurrentProcess
	invoke WriteProcessMemory,eax,AddrResumeThread,offset Old_Code3,size_code3,0; 
	invoke GetModuleHandle,offset nt 
	invoke GetProcAddress,eax,offset QueryInfoStr
	push 0
	push 28;sizeof THread Basic information
	lea esi,ThreadInfo
	push esi
	push 0;ThreadBasicInfo
	push ThreadHandle1
	call eax; NtQueryInformationThread   id    
	lea esi,ThreadInfo.ClientId
	assume esi:PTR CLIENTID
	mov eax,[esi].UniqueProcess
	.if eax!=CurrProcess
		.if NewProcess==1
		;  
		invoke OpenProcess,PROCESS_CREATE_THREAD or PROCESS_VM_WRITE or PROCESS_VM_OPERATION,0,eax;     DLL
		mov hProcess,eax
		invoke GetModuleHandle,offset kern;   Kernel32.dll
		invoke GetProcAddress,eax,offset loadlibraryName;   LoadLibrary
		mov _LoadLibrary,eax
		invoke VirtualAllocEx,hProcess,NULL,dwSize,MEM_RESERVE or MEM_COMMIT,PAGE_READWRITE;    
		mov ParameterForLoadLibrary,eax
		invoke WriteProcessMemory,hProcess,eax,offset lib,dwSize,NULL;    DLL    
		invoke CreateRemoteThread,hProcess,NULL,NULL,_LoadLibrary,ParameterForLoadLibrary,NULL,offset ThreadId;  ,   LoadLibrary,    DLL     .  
		invoke CloseHandle,hProcess
		mov NewProcess,0
		.endif 
	.endif
	push PriviousSuspendCount
	push ThreadHandle1
	call AddrResumeThread
	push eax
	invoke GetCurrentProcess
	invoke WriteProcessMemory,eax,AddrResumeThread,offset code3,size_code3,0; 
	pop eax
	endproc
	ret
NewZwResumeThread endp
End DllMain
